import { AjaxError, BigNumberString, EarnedReward, EVMAccountAddress, EVMContractAddress, EVMPrivateKey, HexString, IDynamicRewardParameter, IpfsCID, Signature, TokenId, URLString, IQueryDeliveryItems, PossibleReward } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
export interface IInsightPlatformRepository {
    clearAllBackups(dataWalletKey: EVMPrivateKey, insightPlatformBaseUrl: URLString, walletAddress: EVMAccountAddress): ResultAsync<void, AjaxError>;
    getSignedUrl(dataWalletKey: EVMPrivateKey, insightPlatformBaseUrl: URLString, fileName: string): ResultAsync<URLString, AjaxError>;
    receivePreviews(consentContractAddress: EVMContractAddress, tokenId: TokenId, queryCID: IpfsCID, signingKey: EVMPrivateKey, insightPlatformBaseUrl: URLString, queryDeliveryItems: IQueryDeliveryItems): ResultAsync<PossibleReward[], AjaxError>;
    deliverInsights(consentContractAddress: EVMContractAddress, tokenId: TokenId, queryCID: IpfsCID, insights: IQueryDeliveryItems, rewardParameters: IDynamicRewardParameter[], signingKey: EVMPrivateKey, insightPlatformBaseUrl: URLString): ResultAsync<EarnedReward[], AjaxError>;
    executeMetatransaction(accountAddress: EVMAccountAddress, contractAddress: EVMContractAddress, nonce: BigNumberString, value: BigNumberString, gas: BigNumberString, data: HexString, metatransactionSignature: Signature, signingKey: EVMPrivateKey, insightPlatformBaseUrl: URLString): ResultAsync<void, AjaxError>;
}
export declare const IInsightPlatformRepositoryType: unique symbol;
//# sourceMappingURL=IInsightPlatformRepository.d.ts.map